c
c-----------------------------------------------------------------------
c
      real*8 function cellcharge (x, y, z)
c
c.....cellcharge - determines the charge of the ion at (x,y,z) in the
c     host crystal, if any.
c
c GLOBAL DATA:
c
      include           'implicit.inc'
      include           'consts.inc'
      include           'molec.inc'
c
c PARAMETERS:
c
      real*8            x, y, z
c
c LOCAL VARIABLES:
c
      real*8            epsilon
      parameter         (epsilon = 1d-5)
      integer           i
      real*8            xx, yy, zz
c
c.....translate (z,y,z) to the primitive cell:
c
      if (x .ge. zero) then
         xx = x - int(x)
      else if (abs(x-int(x)) .le. epsilon) then
         xx = x - int(x)
      else
         xx = x - int(x) + 1
      endif
      if (y .ge. zero) then
         yy = y - int(y)
      else if (abs(y-int(y)) .le. epsilon) then
         yy = y - int(y)
      else
         yy = y - int(y) + 1
      endif
      if (z .ge. zero) then
         zz = z - int(z)
      else if (abs(z-int(z)) .le. epsilon) then
         zz = z - int(z)
      else
         zz = z - int(z) + 1
      endif
c
c.....search for (xx,yy,zz) in the cell atom list:
c
      do i = 1, ncell
         if (abs(xx-xcell(i)) .le. epsilon .and.
     &       abs(yy-ycell(i)) .le. epsilon .and.
     &       abs(zz-zcell(i)) .le. epsilon       ) then
            cellcharge = qneq(typcell(i))
            return
         endif
      enddo
      cellcharge = zero
      return
      end
