c
c.....ewald.inc - data used to run the Ewald method for evaluating
c     the crystal potential at arbitrary sites of the crystal.
c
c.....(a) - reciprocal cell data.
c
      real*8            sc, omega, eta, ap, ar, br
      common /ewald1/   sc, omega, eta, ap(3), ar(3), br(3)
c
c.....(b) - modified sites for the ewald routine.
c
c     nmod ....... number of modified sites.
c     {x,y,z}mod . cell coordinates of the modified sites.
c     xxmod(,) ... two-index matrix that is equivalenced to the single-
c                  index vectors xmod()..zmod().
c     qmod(,2) ... original (,1) and modified charge (,2).
c
      integer           MMOD
      parameter         (MMOD = MHOLE + MCLUS)
      integer           nmod
      real*8            xmod, ymod, zmod, xxmod, qmod
      common /modatm/   xmod(MMOD), ymod(MMOD), zmod(MMOD),
     &                  qmod(MMOD,2), nmod
      dimension         xxmod(MMOD,3)
      equivalence       (xmod(1), xxmod(1,1))
      equivalence       (ymod(1), xxmod(1,2))
      equivalence       (zmod(1), xxmod(1,3))
