c
c-----------------------------------------------------------------------
c
      logical function finputline (u, line)
c
c.....finputline - get next logical line from file with unit number u.
c     Lines ending in the ESCCHAR character are assumed to be continued
c     in the next line.
c
      implicit none
      include           'error.inc'
c
      integer           u
      character*(*)     line
c
      integer           lw, lp1, lw1, leng
      logical           ablank, fgetline
      character*(600)   line1
      character*(1)     ESCCHAR, BLANK
      parameter         (ESCCHAR = '&')
      parameter         (BLANK = ' ')
*      character*(1)     TABCHAR
*      parameter         (TABCHAR = char(9))
c
      if (fgetline (u, line)) then
c
         finputline = .true.
         lw = leng(line)
c
c........Check for continuation lines:
c
         do while (line(lw:lw) .eq. ESCCHAR)
c
c...........Skip terminal blanks of first line and start blanks in
c           continuation lines:
c
            ablank = .false.
            if (fgetline (u, line1)) then
               lw1 = len(line1)
               lw = lw - 1
               do while (line(lw:lw).eq.BLANK .and. lw.gt.1)
                  lw = lw - 1
                  ablank = .true.
               enddo
               lp1 = 1
               do while (line1(lp1:lp1).eq.BLANK .and. lp1.lt.lw1)
                  lp1 = lp1 + 1
                  ablank = .true.
               enddo
               if (ablank) then
                  line = line(1:lw) // BLANK // line1(lp1:lw1)
               else
                  line = line(1:lw) // line1(lp1:lw1)
               endif
               lw = leng(line)
            else
               call error ('finputline',
     &                     'Cannot find continuation line', warning)
               line(lw:lw) = BLANK
               return
            endif
         enddo
c
      else
         finputline = .false.
      endif
c
      return
      end
