c
c.....hash.inc - hashed table of variables and keywords.
c
c  bnames ...... buffer of var names
c  bpointer .... first empty position in bnames
c  nvars ....... number of vars installed
c  varpos(i) ... position of var in bnames
c  nextvar(i) .. next entry with the same hash
c  htable(h) ... last entry with each hash
c  hsize ....... hash table size
c  varrvalue() . value of this var if real
c  varivalue() . value of this var if int
c  vartype() ... type of var (see tokens.inc)
c
c     The use of the hashed table is encapsulated by the routines
c  hashinit(), hinstall(), hlookup(), and showvars(). The internal
c  working is as follows:
c
c  (1) Variables are installed by historical order. The variable nvars
c      contains the number of variables installed. The names are added
c      to bnames separated by nulls, and the first position of his name
c      recorded in varpos(). The variable value is stored in varrvalue()
c      if it is real, or in varivalue() if it is integer.
c  (2) Given the variable name, the routine hash return an integer h.
c  (3) htable(h) contains the number of the last variable having hash
c      value h, or 0 if any. Lets suposse htable(h) is K. When several
c      variables have been installed with the same hash value, then
c      nextvar(K) will point to the number of the next to last var,
c      nextvar(nextvar(K)) will point to the next to the next, an so on.
c
      integer           mhsize, mvars, mbuf
      parameter         (mhsize = 260)
      parameter         (mvars  = 110)
      parameter         (mbuf   = 4095)
      character*(mbuf)  bnames            !buffer of var names
      integer           bpointer,         !first empty position in bname
     &                  nvars,            !number of vars installed
     &                  varpos(0:mvars),  !position of var in bnames
     &                  nextvar(mvars),   !next entry with the same hash
     &                  htable(mhsize),   !last entry with each hash
     &                  hsize             !hash table size
      real*8            varrvalue(mvars)  !value of this var if real
      integer           varivalue(mvars), !value of this var if int
     &                  vartype(mvars)    !type of var (see tokens.inc)
      common /hass/     bnames
      common /hasi/     bpointer, nvars, varpos, nextvar, htable, hsize,
     &                  varivalue, vartype
      common /hasr/     varrvalue
