c
c-----------------------------------------------------------------------
c
      subroutine molcliplin (x1, y1, z1, x2, y2, z2,
     &           xback, xfront, yleft, yright, zbottom, ztop)
c
c.....molcliplin - clips the segment from (x1,y1,z1) to (x2,y2,z2) to be
c     within a rectangular box delimited by (xback,yleft,zbottom) and
c     (xfront,yright,ztop).
c     The point (x1,y1,z1) must be INSIDE the box and the (x2,y2,z2)
c     must be OUTSIDE it.
c
c GLOBAL DATA:
c
      include           'implicit.inc'
c
c PARAMETERS:
c
      real*8            x1, y1, z1, x2, y2, z2
      real*8            xback, xfront, yleft, yright, zbottom, ztop
c
c LOCAL VARIABLES:
c
      real*8            gEPSILON
      parameter         (gEPSILON = 1d-5)
      real*8            x12, y12, z12, t, t1
c
*mdc*if debug
*      write (6,*) 'ClipLin: start --> ', x1, y1, z1, x2, y2, z2
*      write (6,*) 'ClipLin: box ----> ', xback, xfront, yleft, yright,
*     &                                   zbottom, ztop
*mdc*endif
      x12 = x2 - x1
      y12 = y2 - y1
      z12 = z2 - z1
      t = 1.0
      t1 = t
      if (abs(x12).ge.gEPSILON) t1 = (xfront-x1) / x12
      if (t1.ge.0.0 .and. t1.lt.t) t = t1
      if (abs(x12).ge.gEPSILON) t1 = (xback-x1) / x12
      if (t1.ge.0.0 .and. t1.lt.t) t = t1
      if (abs(y12).ge.gEPSILON) t1 = (yleft-y1) / y12
      if (t1.ge.0.0 .and. t1.lt.t) t = t1
      if (abs(y12).ge.gEPSILON) t1 = (yright-y1) / y12
      if (t1.ge.0.0 .and. t1.lt.t) t = t1
      if (abs(z12).ge.gEPSILON) t1 = (zbottom-z1) / z12
      if (t1.ge.0.0 .and. t1.lt.t) t = t1
      if (abs(z12).ge.gEPSILON) t1 = (ztop-z1) / z12
      if (t1.ge.0.0 .and. t1.lt.t) t = t1
      x2 = x1 + x12*t
      y2 = y1 + y12*t
      z2 = z1 + z12*t
*mdc*if debug
*      write (6,*) 'ClipLin: end ----> ', x1, y1, z1, x2, y2, z2
*mdc*endif
      return
      end
