c
c-----------------------------------------------------------------------
c
      subroutine molecule (uin, uout)
c
c.....molecule - reads in the molecular data and drives the modelling.
c
      include           'implicit.inc'
      include           'datatm.inc'
      include           'error.inc'
      include           'molec.inc'
      include           'molge.inc'
      include           'pov.inc'
      include           'strtools.inc'
c
      integer           uin, uout
c
      logical           usedefrgb, usedefrad, autodist, posselect
      logical           justone, dofaces, doedges, doirreducible
      logical           dobicolor
      real*8            rgb(4), rgb2(4), h, s, v
      real*8            ballrad, stickrad, distmin, distmax
      real*8            conerad, conelength, xct, yct, zct
      integer           ndeg, nneig, imtype, imstart, nshells, i, i1
      integer           itexture
      character*(6)     namneig(40)
      character*(80)    filepov, fileoff, filevrml
      character*(80)    title
c
      integer           lp, lw
      character*(600)   line
      character*(80)    word
      character*(6)     atom1, atom2
      logical           doagain, domore1, ok1, ok2
c
      integer           leng
      logical           setdble, setint
      character*(80)    uppcase, getword
      logical           finputline
c
      write (uout,800)
      title = 'molecular plot'
c
      doagain = finputline (uin, line)
c
c.......................................................................
      do while (doagain)
c.......................................................................
c
         lp = 1
         word = uppcase (getword (word, line, lp))
         lw = leng(word)
c
c.......................................................................
         if (word(1:1) .eq. '#') then
c.......................................................................
c
            continue
c
c.......................................................................
         else if (word(1:lw) .eq. 'CRYSTAL') then
c.......................................................................
c
            call molcrystal (uin, uout, title)
c
c.......................................................................
         else if (word(1:lw) .eq. 'BALL') then
c.......................................................................
c
            atom1 = getword (word, line, lp)
            usedefrgb = .true.
            usedefrad = .true.
            imtype = map_none
            imstart = fbufp
            itexture = 0
            word = uppcase (getword (word, line, lp))
            lw = leng(word)
            domore1 = lw.gt.0
            do while (domore1)
               if (word(1:lw) .eq. 'RGB') then
                  ok1 = setdble (rgb(1), line, lp)
                  ok1 = ok1 .and. setdble (rgb(2), line, lp)
                  ok1 = ok1 .and. setdble (rgb(3), line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) usedefrgb = .false.
               else if (word(1:lw) .eq. 'HSV') then
                  ok1 = setdble (h, line, lp)
                  ok1 = ok1 .and. setdble (s, line, lp)
                  ok1 = ok1 .and. setdble (v, line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) then
                     call hsv2rgb (h, s, v, rgb(1), rgb(2), rgb(3))
                     usedefrgb = .false.
                  endif
               else if (word(1:lw) .eq. 'RADIUS') then
                  ok1 = setdble (ballrad, line, lp)
                  ballrad = ballrad * rconversion
                  if (ok1) usedefrad = .false.
               else if (word(1:lw) .eq. 'IMAGE_MAP') then
                  word = uppcase (getword (word, line, lp))
                  lw = leng(word)
                  ok1 = lw.gt.0
                  if (word(1:lw) .eq. 'GIF') then
                     imtype = map_gif
                  else if (word(1:lw) .eq. 'TGA') then
                     imtype = map_tga
                  else
                     ok1 = .false.
                  endif
                  if (ok1) then
                     word = getword (word, line, lp)
                     lw = leng(word)
                     ok1 = lw.gt.0
                     imstart = fbufp
                     filebuffer(fbufp:fbufp+lw) = word(1:lw)//null
                     fbufp = fbufp + lw + 1
                  endif
                  if (.not. ok1) imtype = map_none
               else if (word(1:lw) .eq. 'TEXTURE') then
                  ok1 = setint (itexture, line, lp)
                  if (itexture .gt. 0) then
                     if (.not. usepovtext(itexture)) then
                        call error ('molecule',
     &                    'attempt to use a undeclared POV texture',
     &                    warning)
                        usepovtext(itexture) = .true.
                     endif
                  endif
               endif
               word = uppcase (getword (word, line, lp))
               lw = leng(word)
               domore1 = lw.gt.0
            enddo
            call molballs (atom1, usedefrad, ballrad, usedefrgb, rgb,
     &                     itexture, imtype, imstart, uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'STICK') then
c.......................................................................
c
            atom1 = getword (word, line, lp)
            atom2 = getword (word, line, lp)
            autodist = .true.
            usedefrgb = .true.
            usedefrad = .true.
            dobicolor = .false.
            itexture = 0
            rgb(1) = 1d0
            rgb(2) = 0d0
            rgb(3) = 0d0
            rgb(4) = 0d0
            rgb2(1) = 0d0
            rgb2(2) = 1d0
            rgb2(3) = 0d0
            rgb2(4) = 0d0
            word = uppcase (getword (word, line, lp))
            lw = leng(word)
            domore1 = lw.gt.0
            do while (domore1)
               if (word(1:lw) .eq. 'RGB') then
                  ok1 = setdble (rgb(1), line, lp)
                  ok1 = ok1 .and. setdble (rgb(2), line, lp)
                  ok1 = ok1 .and. setdble (rgb(3), line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) usedefrgb = .false.
               else if (word(1:lw) .eq. 'RGB2') then
                  ok1 = setdble (rgb2(1), line, lp)
                  ok1 = ok1 .and. setdble (rgb2(2), line, lp)
                  ok1 = ok1 .and. setdble (rgb2(3), line, lp)
                  rgb2(4) = 0d0
                  ok2 = setdble (rgb2(4), line, lp)
                  if (ok1) usedefrgb = .false.
               else if (word(1:lw) .eq. 'HSV') then
                  ok1 = setdble (h, line, lp)
                  ok1 = ok1 .and. setdble (s, line, lp)
                  ok1 = ok1 .and. setdble (v, line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) then
                     call hsv2rgb (h, s, v, rgb(1), rgb(2), rgb(3))
                     usedefrgb = .false.
                  endif
               else if (word(1:lw) .eq. 'HSV2') then
                  ok1 = setdble (h, line, lp)
                  ok1 = ok1 .and. setdble (s, line, lp)
                  ok1 = ok1 .and. setdble (v, line, lp)
                  rgb2(4) = 0d0
                  ok2 = setdble (rgb2(4), line, lp)
                  if (ok1) then
                     call hsv2rgb (h, s, v, rgb2(1), rgb2(2), rgb2(3))
                     usedefrgb = .false.
                  endif
               else if (word(1:lw) .eq. 'BICOLOR') then
                  dobicolor = .true.
               else if (word(1:lw) .eq. 'RADIUS') then
                  ok1 = setdble (stickrad, line, lp)
                  if (ok1) usedefrad = .false.
                  stickrad = stickrad * rconversion
               else if (word(1:lw) .eq. 'DIST') then
                  ok1 = setdble (distmin, line, lp)
                  ok1 = ok1 .and. setdble (distmax, line, lp)
                  if (.not. ok1) call error ('molecule',
     &               'DIST error in STICK order', faterr)
                  autodist = .false.
                  distmin = distmin * rconversion
                  distmax = distmax * rconversion
               else if (word(1:lw) .eq. 'AUTO') then
                  autodist = .true.
               else if (word(1:lw) .eq. 'TEXTURE') then
                  ok1 = setint (itexture, line, lp)
                  if (itexture .gt. 0) then
                     if (.not. usepovtext(itexture)) then
                        call error ('molecule',
     &                    'attempt to use a undeclared POV texture',
     &                    warning)
                        usepovtext(itexture) = .true.
                     endif
                  endif
               endif
               word = uppcase (getword (word, line, lp))
               lw = leng(word)
               domore1 = lw.gt.0
            enddo
            if (usedefrad) then
               stickrad = 0.1d0 * rconversion
            endif
            call molstick (atom1, atom2, autodist, distmin, distmax,
     &               stickrad, dobicolor, usedefrgb, rgb, rgb2,
     &               itexture, uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'ARROW') then
c.......................................................................
c
            atom1 = getword (word, line, lp)
            atom2 = getword (word, line, lp)
            autodist = .true.
            usedefrgb = .true.
            usedefrad = .true.
            itexture = 0
            word = uppcase (getword (word, line, lp))
            lw = leng(word)
            domore1 = lw.gt.0
            do while (domore1)
               if (word(1:lw) .eq. 'RGB') then
                  ok1 = setdble (rgb(1), line, lp)
                  ok1 = ok1 .and. setdble (rgb(2), line, lp)
                  ok1 = ok1 .and. setdble (rgb(3), line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) usedefrgb = .false.
               else if (word(1:lw) .eq. 'HSV') then
                  ok1 = setdble (h, line, lp)
                  ok1 = ok1 .and. setdble (s, line, lp)
                  ok1 = ok1 .and. setdble (v, line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) then
                     call hsv2rgb (h, s, v, rgb(1), rgb(2), rgb(3))
                     usedefrgb = .false.
                  endif
               else if (word(1:lw) .eq. 'SIZE') then
                  ok1 = setdble (stickrad, line, lp)
                  ok1 = ok1 .and. setdble (conerad, line, lp)
                  ok1 = ok1 .and. setdble (conelength, line, lp)
                  if (ok1) usedefrad = .false.
                  stickrad = stickrad * rconversion
                  conerad = conerad * rconversion
                  conelength = conelength * rconversion
               else if (word(1:lw) .eq. 'DIST') then
                  ok1 = setdble (distmin, line, lp)
                  ok1 = ok1 .and. setdble (distmax, line, lp)
                  if (.not. ok1) call error ('molecule',
     &               'DIST error in STICK order', faterr)
                  autodist = .false.
                  distmin = distmin * rconversion
                  distmax = distmax * rconversion
               else if (word(1:lw) .eq. 'TEXTURE') then
                  ok1 = setint (itexture, line, lp)
                  if (itexture .gt. 0) then
                     if (.not. usepovtext(itexture)) then
                        call error ('molecule',
     &                    'attempt to use a undeclared POV texture',
     &                    warning)
                        usepovtext(itexture) = .true.
                     endif
                  endif
               endif
               word = uppcase (getword (word, line, lp))
               lw = leng(word)
               domore1 = lw.gt.0
            enddo
            if (usedefrad) then
               stickrad = 0.1d0 * rconversion
               conerad = 0.16d0 * rconversion
               conelength = 0.2d0 * rconversion
            endif
            if (autodist) then
               distmin = 0d0
               distmax = 1d4
            endif
            call molarrow (atom1, atom2, distmin, distmax,
     &           stickrad, conerad, conelength, usedefrgb, rgb,
     &           itexture, uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'POLYHEDRON') then
c.......................................................................
c
            atom1 = getword (word, line, lp)
            usedefrad = .true.
            usedefrgb = .true.
            posselect = .false.
            autodist = .true.
            dofaces = .true.
            doedges = .false.
            nneig = 0
            itexture = 0
            word = uppcase (getword (word, line, lp))
            lw = leng(word)
            domore1 = lw.gt.0
            do while (domore1)
               if (word(1:lw) .eq. 'AT') then
                  ok1 = setdble (xct, line, lp)
                  ok1 = ok1 .and. setdble (yct, line, lp)
                  ok1 = ok1 .and. setdble (zct, line, lp)
                  if (.not. ok1) call error ('molecule',
     &               'AT error in POLYHEDRON order', faterr)
                  posselect = .true.
               else if (word(1:lw) .eq. 'DIST') then
                  ok1 = setdble (distmin, line, lp)
                  ok1 = ok1 .and. setdble (distmax, line, lp)
                  if (.not. ok1) call error ('molecule',
     &               'DIST error in POLYHEDRON order', faterr)
                  autodist = .false.
                  distmin = distmin * rconversion
                  distmax = distmax * rconversion
               else if (word(1:lw) .eq. 'AUTO') then
                  autodist = .true.
               else if (word(1:lw) .eq. 'RGB') then
                  ok1 = setdble (rgb(1), line, lp)
                  ok1 = ok1 .and. setdble (rgb(2), line, lp)
                  ok1 = ok1 .and. setdble (rgb(3), line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) usedefrgb = .false.
               else if (word(1:lw) .eq. 'HSV') then
                  ok1 = setdble (h, line, lp)
                  ok1 = ok1 .and. setdble (s, line, lp)
                  ok1 = ok1 .and. setdble (v, line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) then
                     call hsv2rgb (h, s, v, rgb(1), rgb(2), rgb(3))
                     usedefrgb = .false.
                  endif
               else if (word(1:lw) .eq. 'FACES') then
                  dofaces = .true.
                  doedges = .false.
               else if (word(1:lw) .eq. 'EDGES') then
                  dofaces = .false.
                  doedges = .true.
               else if (word(1:lw) .eq. 'BOTH') then
                  dofaces = .true.
                  doedges = .true.
               else if (word(1:lw) .eq. 'RADIUS') then
                  ok1 = setdble (stickrad, line, lp)
                  if (ok1) usedefrad = .false.
                  stickrad = stickrad * rconversion
               else if (word(1:lw) .eq. 'BY') then
                  namneig(nneig+1) = getword (word, line, lp)
                  lw = leng(word)
                  do while (lw .gt. 0)
                     nneig = nneig + 1
                     namneig(nneig+1) = getword (word, line, lp)
                     lw = leng(word)
                  enddo
               else if (word(1:lw) .eq. 'TEXTURE') then
                  ok1 = setint (itexture, line, lp)
                  if (itexture .gt. 0) then
                     if (.not. usepovtext(itexture)) then
                        call error ('molecule',
     &                    'attempt to use a undeclared POV texture',
     &                    warning)
                        usepovtext(itexture) = .true.
                     endif
                  endif
               endif
               word = uppcase (getword (word, line, lp))
               lw = leng(word)
               domore1 = lw .gt. 0
            enddo
            if (usedefrad) then
               stickrad = 0.1d0 * rconversion
            endif
            call molplh (atom1, posselect, xct, yct, zct, autodist,
     &                   distmin, distmax, nneig, namneig, usedefrgb,
     &                   rgb, itexture,
     &                   dofaces, doedges, stickrad, uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'UNITCELL') then
c.......................................................................
c
            usedefrgb = .true.
            usedefrad = .true.
            justone = .true.
            itexture = 0
            word = uppcase (getword (word, line, lp))
            lw = leng(word)
            domore1 = lw.gt.0
            do while (domore1)
               if (word(1:lw) .eq. 'RGB') then
                  ok1 = setdble (rgb(1), line, lp)
                  ok1 = ok1 .and. setdble (rgb(2), line, lp)
                  ok1 = ok1 .and. setdble (rgb(3), line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) usedefrgb = .false.
               else if (word(1:lw) .eq. 'HSV') then
                  ok1 = setdble (h, line, lp)
                  ok1 = ok1 .and. setdble (s, line, lp)
                  ok1 = ok1 .and. setdble (v, line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) then
                     call hsv2rgb (h, s, v, rgb(1), rgb(2), rgb(3))
                     usedefrgb = .false.
                  endif
               else if (word(1:lw) .eq. 'RADIUS') then
                  ok1 = setdble (stickrad, line, lp)
                  if (ok1) usedefrad = .false.
                  stickrad = stickrad * rconversion
               else if (word(1:lw) .eq. 'ONE') then
                  justone = .true.
               else if (word(1:lw) .eq. 'MANY') then
                  justone = .false.
               else if (word(1:lw) .eq. 'TEXTURE') then
                  ok1 = setint (itexture, line, lp)
                  if (itexture .gt. 0) then
                     if (.not. usepovtext(itexture)) then
                        call error ('molecule',
     &                    'attempt to use a undeclared POV texture',
     &                    warning)
                        usepovtext(itexture) = .true.
                     endif
                  endif
               endif
               word = uppcase (getword (word, line, lp))
               lw = leng(word)
               domore1 = lw.gt.0
            enddo
            if (usedefrad) then
               stickrad = 0.1d0 * rconversion
            endif
            call moluc (justone, stickrad, usedefrgb, rgb,
     &                  itexture, uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'WIGNER-SEITZ') then
c.......................................................................
c
            usedefrgb = .true.
            usedefrad = .true.
            dofaces = .true.
            doedges = .false.
            doirreducible = .false.
            itexture = 0
            xct = 0d0
            yct = 0d0
            zct = 0d0
            word = uppcase (getword (word, line, lp))
            lw = leng(word)
            domore1 = lw.gt.0
            do while (domore1)
               if (word(1:lw) .eq. 'AT') then
                  ok1 = setdble (xct, line, lp)
                  ok1 = ok1 .and. setdble (yct, line, lp)
                  ok1 = ok1 .and. setdble (zct, line, lp)
               else if (word(1:lw) .eq. 'FACES') then
                  dofaces = .true.
                  doedges = .false.
               else if (word(1:lw) .eq. 'EDGES') then
                  dofaces = .false.
                  doedges = .true.
               else if (word(1:lw) .eq. 'BOTH') then
                  dofaces = .true.
                  doedges = .true.
               else if (word(1:lw) .eq. 'IRREDUCIBLE') then
                  doirreducible = .true.
               else if (word(1:lw) .eq. 'RGB') then
                  ok1 = setdble (rgb(1), line, lp)
                  ok1 = ok1 .and. setdble (rgb(2), line, lp)
                  ok1 = ok1 .and. setdble (rgb(3), line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) usedefrgb = .false.
               else if (word(1:lw) .eq. 'HSV') then
                  ok1 = setdble (h, line, lp)
                  ok1 = ok1 .and. setdble (s, line, lp)
                  ok1 = ok1 .and. setdble (v, line, lp)
                  rgb(4) = 0d0
                  ok2 = setdble (rgb(4), line, lp)
                  if (ok1) then
                     call hsv2rgb (h, s, v, rgb(1), rgb(2), rgb(3))
                     usedefrgb = .false.
                  endif
               else if (word(1:lw) .eq. 'RADIUS') then
                  ok1 = setdble (stickrad, line, lp)
                  if (ok1) usedefrad = .false.
                  stickrad = stickrad * rconversion
               else if (word(1:lw) .eq. 'TEXTURE') then
                  ok1 = setint (itexture, line, lp)
                  if (itexture .gt. 0) then
                     if (.not. usepovtext(itexture)) then
                        call error ('molecule',
     &                    'attempt to use a undeclared POV texture',
     &                    warning)
                        usepovtext(itexture) = .true.
                     endif
                  endif
               endif
               word = uppcase (getword (word, line, lp))
               lw = leng(word)
               domore1 = lw.gt.0
            enddo
            if (usedefrad) then
               stickrad = 0.1d0 * rconversion
            endif
            call molws (xct, yct, zct, usedefrgb, rgb, itexture,
     &                  dofaces, doedges, doirreducible, stickrad, uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'MADELUNG') then
c.......................................................................
c
            call madelung (line, lp, uin, uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'POVRAY') then
c.......................................................................
c
c...........Select output of a povray file:
c
            if (leng(line) .gt. lp) filepov = getword (word, line, lp)
            call molnormal ()
            call getnormals (ndeg, uout)
            if (ndeg .gt. 0) then
               call removedeg (ndeg, uout)
               call getnormals (ndeg, uout)
            endif
            call writepov (filepov, title, uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'OFF') then
c.......................................................................
c
c...........Select output of an OFF file:
c
            if (leng(line) .gt. lp) fileoff = getword (word, line, lp)
            call molnormal ()
            call writeoff (fileoff, title, uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'VRML') then
c.......................................................................
c
c...........Select output of an VRML file:
c
            if (leng(line) .gt. lp) filevrml = getword (word, line, lp)
            call molnormal ()
            call writevrml1 (filevrml, title, uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'ENVIRON') then
c.......................................................................
c
c...........Analyze the environ of the symmetry different atoms:
c
            ok1 = setint (nshells, line, lp)
            if (.not. ok1) nshells = 6
            write (uout,820) 'Pure crystal atoms'
            do i = 1, nneq
               xct = xneq(i)
               yct = yneq(i)
               zct = zneq(i)
               atom1 = namneq(i)
               call molenv (atom1, xct, yct, zct, nshells, 1, uout)
            enddo
            write (uout,820) 'cluster atoms'
            i1 = 1
            do i = 1, nneqclus
               xct = xclus(i1)
               yct = yclus(i1)
               zct = zclus(i1)
               atom1 = namclus(i)
               call molenv (atom1, xct, yct, zct, nshells, 1, uout)
               i1 = i1 + multclus(i)
            enddo
            call molbndgeom (uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'SET') then
c.......................................................................
c
            call setvariables (line, lp, uout)
c
c.......................................................................
         else if (word(1:lw) .eq. 'TITLE') then
c.......................................................................
c
            title = line(lp:leng(line))
c
c.......................................................................
         else if (word(1:lw) .eq. 'ENDMOLECULE') then
c.......................................................................
c
            doagain = .false.
c
c.......................................................................
         endif
c.......................................................................
c
c.......................................................................
         if (doagain) doagain = finputline (uin, line)
      enddo
c.......................................................................
c
      write (uout,810) gnpt, gnball, gnstk, gnpol, gnplh
c
c.....FORMATS:
c
 800  format (/
     & 1x, '*******************************************************'/
     & 1x, '*** MOLECULE: Starting molecular plot *****************'/
     & 1x, '*******************************************************'/)
 810  format (/
     & 1x, '--Elements in the molecular graphics database--'/
     & 1x, 'Total number of points: ', i5/
     & 1x, '       Number of balls: ', i5/
     & 1x, '      Number of sticks: ', i5/
     & 1x, '    Number of polygons: ', i5/
     & 1x, '   Number of polyhedra: ', i5)
 820  format (/
     & 1x, 'Analysis of the molecular environment of the ', a)
c
      end
