c
c-----------------------------------------------------------------------
c
      subroutine moluc (justone, stickrad, usedefrgb, rgb, itexture,
     &                  uout)
c
c.....moluc - Add a frame representing the unit cell.
c
      include           'implicit.inc'
      include           'error.inc'
      include           'molec.inc'
      include           'molge.inc'
c
      integer           uout, itexture
      real*8            stickrad, rgb(4)
      logical           justone, usedefrgb
c
      integer           i, i0, i1, j, k, idif
c
      write (uout,800)
c
      if (justone) then
c
c........Add the unit cell vertices:
c
         if (gnpt+8 .gt. GMPT) call error ('moluc',
     &          'Too many vertices. Increase GMPT', faterr)
         i0 = gnpt
         gnpt = i0 + 1
         gxpt(gnpt) = 0d0
         gypt(gnpt) = 0d0
         gzpt(gnpt) = 0d0
         gnpt = i0 + 2
         gxpt(gnpt) = 1d0
         gypt(gnpt) = 0d0
         gzpt(gnpt) = 0d0
         gnpt = i0 + 3
         gxpt(gnpt) = 0d0
         gypt(gnpt) = 1d0
         gzpt(gnpt) = 0d0
         gnpt = i0 + 4
         gxpt(gnpt) = 0d0
         gypt(gnpt) = 0d0
         gzpt(gnpt) = 1d0
         gnpt = i0 + 5
         gxpt(gnpt) = 1d0
         gypt(gnpt) = 1d0
         gzpt(gnpt) = 0d0
         gnpt = i0 + 6
         gxpt(gnpt) = 1d0
         gypt(gnpt) = 0d0
         gzpt(gnpt) = 1d0
         gnpt = i0 + 7
         gxpt(gnpt) = 0d0
         gypt(gnpt) = 1d0
         gzpt(gnpt) = 1d0
         gnpt = i0 + 8
         gxpt(gnpt) = 1d0
         gypt(gnpt) = 1d0
         gzpt(gnpt) = 1d0
c
c........Add the sticks connecting pairs of points:
c
         if (gnstk+12 .gt. GMSTK) call error ('moluc',
     &          'Too many sticks. Increase GMSTK', faterr)
         i1 = gnstk
         do i = gnstk+1, gnstk+12
            gstkrad(i) = stickrad
            gstkdefrgb(i) = usedefrgb
            gstkrgbf(1,i) = rgb(1)
            gstkrgbf(2,i) = rgb(2)
            gstkrgbf(3,i) = rgb(3)
            gstkrgbf(4,i) = rgb(4)
            gstktext(i) = itexture
         enddo
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+1
         gstkpt(2,gnstk) = i0+2
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+1
         gstkpt(2,gnstk) = i0+3
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+1
         gstkpt(2,gnstk) = i0+4
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+2
         gstkpt(2,gnstk) = i0+5
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+2
         gstkpt(2,gnstk) = i0+6
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+3
         gstkpt(2,gnstk) = i0+5
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+3
         gstkpt(2,gnstk) = i0+7
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+4
         gstkpt(2,gnstk) = i0+6
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+4
         gstkpt(2,gnstk) = i0+7
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+5
         gstkpt(2,gnstk) = i0+8
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+6
         gstkpt(2,gnstk) = i0+8
         gnstk = gnstk + 1
         gstkpt(1,gnstk) = i0+7
         gstkpt(2,gnstk) = i0+8
c
      else
c
c........Add cell networks to cover the crystal box completely:
c
         i0 = gnpt
c
c........First get the vertices:
c
         do i = int(x0grfclip), int(x1grfclip)
            do j = int(y0grfclip), int(y1grfclip)
               do k = int(z0grfclip), int(z1grfclip)
                  gnpt = gnpt + 1
                  if (gnpt .gt. GMPT) call error ('moluc',
     &               'Too many vertices. Increase GMPT', faterr)
                  gxpt(gnpt) = dble(i)
                  gypt(gnpt) = dble(j)
                  gzpt(gnpt) = dble(k)
               enddo
            enddo
         enddo
c
c........Get now the sticks connecting vertices:
c
         i1 = gnstk
         do i = i0+1, gnpt-1
            do j = i+1, gnpt
               idif = abs(gxpt(i)-gxpt(j)) + abs(gypt(i)-gypt(j)) +
     &                abs(gzpt(i)-gzpt(j))
               if (idif .eq. 1) then
                  gnstk = gnstk + 1
                  if (gnstk .gt. GMSTK) call error ('moluc',
     &               'Too many sticks. Increase GMSTK', faterr)
                  gstkpt(1,gnstk) = i
                  gstkpt(2,gnstk) = j
                  gstkrad(gnstk) = stickrad
                  gstkdefrgb(gnstk) = usedefrgb
                  gstkrgbf(1,gnstk) = rgb(1)
                  gstkrgbf(2,gnstk) = rgb(2)
                  gstkrgbf(3,gnstk) = rgb(3)
                  gstkrgbf(4,gnstk) = rgb(4)
               endif
            enddo
         enddo
      endif
c
c.....transform points to cartesian coordinates:
c
      do i = i0 + 1, gnpt
         gxpt(i) = gxpt(i)*crys2car(1) + gypt(i)*crys2car(2) +
     &             gzpt(i)*crys2car(3)
         gypt(i) = gypt(i)*crys2car(4) + gzpt(i)*crys2car(5)
         gzpt(i) = gzpt(i)*crys2car(6)
      enddo
*mdc*if debug
*      write (uout,900) gnpt-i0
*      do i = i0+1, gnpt
*         write (uout,905) gxpt(i), gypt(i), gzpt(i)
*      enddo
*      write (uout,910) gnstk-i1
*      write (uout,915) (gstkpt(1,i), gstkpt(2,i), i = i1+1, gnstk)
* 900  format (1x, 'Points added: ', i5)
* 905  format (1x, 3f15.6)
* 910  format (1x, 'Sticks added: ', i5)
* 915  format (1x, 12 (2i2, 2x))
*mdc*endif
c
c.....FORMATS:
c
 800  format (/
     & 1x, 'MOLUC: Adding the unit cell frame.')
c
      end
