c
c-----------------------------------------------------------------------
c
      subroutine popandexecute (ierr)
c
c.....popandexecute - execute the operation on top of the operator
c     stack.
c
      include           'implicit.inc'
      include           'consts.inc'
      include           'error.inc'
      include           'opstack.inc'
      include           'tokens.inc'
c
      integer           ierr, ierr0
c
      real*8            power, factrl, erf_private, erfc_private, gammp
      real*8            x1, x2, xarg, aarg
      integer           i1, i2
c
      ierr = 0
      if (nopstk .le. 0) then
         call error ('popandexecute',
     &               'premature end of operators stack', warning)
         ierr = 1
         return
      endif
c
      if (tyopstk(nopstk) .eq. tpoperator) then
c
c             **********************
c             ** BINARY OPERATORS **
c             **********************
c
         if (nnumstk .lt. 2) then
            call error ('popandexecute',
     &                  'premature end of operands stack', warning)
            ierr = 1
            return
         endif
c
         if (opstk(nopstk) .eq. ot_add) then
            numstk(nnumstk-1) = numstk(nnumstk-1) + numstk(nnumstk)
            nnumstk = nnumstk - 1
c
         else if (opstk(nopstk) .eq. ot_subs) then
            numstk(nnumstk-1) = numstk(nnumstk-1) - numstk(nnumstk)
            nnumstk = nnumstk - 1
c
         else if (opstk(nopstk) .eq. ot_mult) then
            numstk(nnumstk-1) = numstk(nnumstk-1) * numstk(nnumstk)
            nnumstk = nnumstk - 1
c
         else if (opstk(nopstk) .eq. ot_div) then
            if (numstk(nnumstk) .eq. zero) then
               call error ('popandexecute', 'division by zero', warning)
               ierr = 2
               return
            endif
            numstk(nnumstk-1) = numstk(nnumstk-1) / numstk(nnumstk)
            nnumstk = nnumstk - 1
c
         else if (opstk(nopstk) .eq. ot_elev) then
            numstk(nnumstk-1) =
     &            power(numstk(nnumstk-1), numstk(nnumstk), ierr0)
            nnumstk = nnumstk - 1
            if (ierr0 .ne. 0) then
               call error ('popandexecute',
     &              'real powers of negative numbers are not defined',
     &              warning)
            endif
c
         else if (opstk(nopstk) .eq. ot_gt) then
            if (numstk(nnumstk-1) .gt. numstk(nnumstk)) then
               numstk(nnumstk-1) =  1    ! ----TRUE----
            else
               numstk(nnumstk-1) = -1    ! ----FALSE---
            endif
            nnumstk = nnumstk - 1
c
         else if (opstk(nopstk) .eq. ot_lt) then
            if (numstk(nnumstk-1) .lt. numstk(nnumstk)) then
               numstk(nnumstk-1) =  1    ! ----TRUE----
            else
               numstk(nnumstk-1) = -1    ! ----FALSE---
            endif
            nnumstk = nnumstk - 1
c
         else if (opstk(nopstk) .eq. ot_ge) then
            if (numstk(nnumstk-1) .ge. numstk(nnumstk)) then
               numstk(nnumstk-1) =  1    ! ----TRUE----
            else
               numstk(nnumstk-1) = -1    ! ----FALSE---
            endif
            nnumstk = nnumstk - 1
c
         else if (opstk(nopstk) .eq. ot_le) then
            if (numstk(nnumstk-1) .le. numstk(nnumstk)) then
               numstk(nnumstk-1) =  1    ! ----TRUE----
            else
               numstk(nnumstk-1) = -1    ! ----FALSE---
            endif
            nnumstk = nnumstk - 1
c
         else if (opstk(nopstk) .eq. ot_eq) then
            if (numstk(nnumstk-1) .eq. numstk(nnumstk)) then
               numstk(nnumstk-1) =  1    ! ----TRUE----
            else
               numstk(nnumstk-1) = -1    ! ----FALSE---
            endif
            nnumstk = nnumstk - 1
c
         else if (opstk(nopstk) .eq. ot_ne) then
            if (numstk(nnumstk-1) .ne. numstk(nnumstk)) then
               numstk(nnumstk-1) =  1    ! ----TRUE----
            else
               numstk(nnumstk-1) = -1    ! ----FALSE---
            endif
            nnumstk = nnumstk - 1
c
         else if (opstk(nopstk) .eq. ot_and) then
            if (numstk(nnumstk-1).gt.0  .and.
     &          numstk(nnumstk).gt.0) then
               numstk(nnumstk-1) =  1    ! ----TRUE----
            else
               numstk(nnumstk-1) = -1    ! ----FALSE---
            endif
            nnumstk = nnumstk - 1
c
         else if (opstk(nopstk) .eq. ot_or) then
            if (numstk(nnumstk-1).lt.0  .and.
     &          numstk(nnumstk).lt.0) then
               numstk(nnumstk-1) = -1    ! ----FALSE---
            else
               numstk(nnumstk-1) =  1    ! ----TRUE----
            endif
            nnumstk = nnumstk - 1
c
         else
            call error ('popandexecute',
     &         'incorrectly formatted expression', faterr)
            ierr = 3
            return
         endif
         nopstk = nopstk - 1
c
      else if (tyopstk(nopstk) .eq. tpunary) then
c
c             *********************
c             ** UNARY OPERATORS **
c             *********************
c
         if (nnumstk .lt. 1) then
            call error ('popandexecute',
     &                  'premature end of operands stack', warning)
            ierr = 1
            return
         endif
         if (opstk(nopstk) .eq. ot_uminus) then
            numstk(nnumstk) = -numstk(nnumstk)
         endif
         nopstk = nopstk - 1
c
      else if (tyopstk(nopstk) .eq. tpcomma) then
c
c             ********************
c             ** COMMA OPERATOR **
c             ********************
c
         nopstk = nopstk - 1
c
      else if (tyopstk(nopstk) .eq. tpfunction) then
c
c             *************************
c             ** INTRINSIC FUNCTIONS **
c             *************************
c
c  The next portion of code is dependent of the values assigned to the
c function types in tokens.inc. For the correct working of this routine,
c the values assigned to the ft_ constants should be:
c
c   ft_abs = 1     ft_sqrt = 2     ft_log = 3     ft_log10 = 4
c   ft_sin = 5     ft_cos = 6      ft_tan = 7     ft_asin = 8
c   ft_acos = 9    ft_atan = 10    ft_exp = 11    ft_sinh =12
c   ft_cosh = 13   ft_tanh = 14  ... (see complete list in tokens.inc)
c
         if (nnumstk .lt. 1) then
            call error ('popandexecute',
     &                  'premature end of operands stack', warning)
            ierr = 1
            return
         endif
         goto (
     &         201, 202, 203, 204, 205, 206, 207, 208, 209, 210,
     &         211, 212, 213, 214, 215, 216, 217, 218, 219, 220,
     &         221, 222, 223, 224, 225, 226, 227
     &        )  opstk(nopstk)
c
c........abs function:
c
 201     numstk(nnumstk) = abs (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........sqrt function:
c
 202     if (numstk(nnumstk) .lt. zero) then
            call error ('popandexecute',
     &                  'square root of a negative number', warning)
            ierr = 4
            return
         endif
         numstk(nnumstk) = sqrt (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........log function:
c
 203     if (numstk(nnumstk) .le. zero) then
            call error ('popandexecute',
     &           'logarithm of zero or a negative number', warning)
            ierr = 5
            return
         endif
         numstk(nnumstk) = log (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........log10 function:
c
 204     if (numstk(nnumstk) .le. zero) then
            call error ('popandexecute',
     &           'logarithm of zero or a negative number', warning)
            ierr = 5
            return
         endif
         numstk(nnumstk) = log10 (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........sin function:
c
 205     numstk(nnumstk) = sin (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........cos function:
c
 206     numstk(nnumstk) = cos (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........tan function:
c
 207     numstk(nnumstk) = tan (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........asin function:
c
 208     if (abs(numstk(nnumstk)) .gt. 1d0) then
            call error ('popandexecute',
     &           'sin cannot be larger than 1', faterr)
            ierr = 6
            return
         endif
         numstk(nnumstk) = asin (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........acos function:
c
 209     if (abs(numstk(nnumstk)) .gt. 1d0) then
            call error ('popandexecute',
     &           'cos cannot be larger than 1', faterr)
            ierr = 6
            return
         endif
         numstk(nnumstk) = acos (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........atan function:
c
 210     numstk(nnumstk) = atan (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........exp function:
c
 211     numstk(nnumstk) = exp (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........sinh function:
c
 212     numstk(nnumstk) = sinh (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........cosh function:
c
 213     numstk(nnumstk) = cosh (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........tanh function:
c
 214     numstk(nnumstk) = tanh (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........int function:
c
 215     numstk(nnumstk) = int (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........frac function:
c
 216     numstk(nnumstk) = numstk(nnumstk)  - int (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........fact (factorial) function:
c
 217     numstk(nnumstk) = factrl (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........mod function:
c
 218     if (nnumstk .lt. 2) then
            call error ('popandexecute',
     &                  'premature end of operands stack', warning)
            ierr = 1
            return
         endif
         i2 = int (numstk(nnumstk))
         nnumstk = nnumstk - 1
         i1 = int (numstk(nnumstk))
         numstk(nnumstk) = mod (i1, i2)
         nopstk = nopstk - 1
         return
c
c........erf (error) function:
c
 219     numstk(nnumstk) = erf_private (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........erfc (complementary error) function:
c
 220     numstk(nnumstk) = erfc_private (numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........atan2 function:
c
 221     x2 = numstk(nnumstk)
         nnumstk = nnumstk - 1
         x1 = numstk(nnumstk)
         numstk(nnumstk) = atan2 (x1, x2)
         nopstk = nopstk - 1
         return
c
c........igamma (incomplete gamma) function:
c
 222     if (nnumstk .lt. 2) then
            call error ('popandexecute',
     &                  'premature end of operands stack', warning)
            ierr = 1
            return
         endif
         xarg = numstk(nnumstk)
         nnumstk = nnumstk - 1
         aarg = numstk(nnumstk)
         numstk(nnumstk) = gammp (aarg, xarg)
         nopstk = nopstk - 1
         return
c
c........sgn (sign) function:
c
 223     numstk(nnumstk) = sign(1d0,numstk(nnumstk))
         nopstk = nopstk - 1
         return
c
c........min function:
c
 224     if (nnumstk .lt. 2) then
            call error ('popandexecute',
     &                  'premature end of operands stack', warning)
            ierr = 1
            return
         endif
         xarg = numstk(nnumstk)
         nnumstk = nnumstk - 1
         aarg = numstk(nnumstk)
         numstk(nnumstk) = min (aarg, xarg)
         nopstk = nopstk - 1
         return
c
c........max function:
c
 225     if (nnumstk .lt. 2) then
            call error ('popandexecute',
     &                  'premature end of operands stack', warning)
            ierr = 1
            return
         endif
         xarg = numstk(nnumstk)
         nnumstk = nnumstk - 1
         aarg = numstk(nnumstk)
         numstk(nnumstk) = max (aarg, xarg)
         nopstk = nopstk - 1
         return
c
c........if function:
c
 226     if (nnumstk .lt. 3) then
            call error ('popandexecute',
     &                  'premature end of operands stack', warning)
            ierr = 1
            return
         endif
         if (numstk(nnumstk-2) .gt. 0) then
            numstk(nnumstk-2) = numstk(nnumstk-1)
         else
            numstk(nnumstk-2) = numstk(nnumstk)
         endif
         nnumstk = nnumstk - 2
         nopstk = nopstk - 1
         return
c
 227     continue
         call error ('popandexecute', 'function not defined', warning)
         ierr = 7
         return
c
      else if (tyopstk(nopstk) .eq. tpopenpar) then
         call error ('popandexecute', 'mismatched parenthesis', warning)
         ierr = 8
c
      else
         call error ('popandexecute', 'format error in expression',
     &      warning)
         ierr = 9
c
      endif
      return
      end
