c
c-----------------------------------------------------------------------
c
      subroutine povinit ()
c
c.....povinit - Declares initial values for some parameters used in the
c     POV-Ray output.
c
      implicit none
      include           'pov.inc'
      integer           i
c
c.....Angular position (theta,phi) of the camera:
c
      usecamangle = .true.
      camangle(1) =  70
      camangle(2) =  20
c
c.....Angle of vision of the camera:
c
      camangle(3) =  40
c
c.....Use zoom=1 for a standard perspective view. Higher values will
c     tend to a parallel projection:
c
      zoom = 10
c
c.....The following definition will emulate a Right-handed axis system,
c     with z being up, y to the right of the screen, and x pointing from
c     the screen to the viewer:
c
      SKY(1) = 0d0
      SKY(2) = 0d0
      SKY(3) = 1d0
c
      VUV(1) = 0d0
      VUV(2) = 0d0
      VUV(3) = 1d0
c
      RHT(1) = 1d0
      RHT(2) = 0d0
      RHT(3) = 0d0
c
      DRT(1) = 0d0
      DRT(2) = 1d0
      DRT(3) = 0d0
c
c.....Initialize lights:
c
      n_light = 0
      def_light = .true.
      do i = 1, MLIGHT
         use_light(i) = .false.
      enddo
c
c.....Default options for the POV output:
c
      fullpov = .true.
      putaxes = .false.
      mirrors = .false.
      use_planes = .true.
      mirrx = -3d0
      mirry = -3d0
      mirrz = -3d0
      equalscale = scale_all
      def_texture =
     &   'finish{specular 1 roughness 0.001 reflection 0.4}'
c     object_texture = 'Stone12'
      object_texture =
     & 'Cork finish{specular 1 roughness 0.001 reflection 0.4}'
      def_background = 'background {color NavyBlue}'
      stick_texture = 'DMFWood4 scale 0.05 finish {Shiny}'
      ball_texture = 'pigment {color Blue} '//
     & 'finish{specular 1 roughness 0.001 reflection 0.4}'
      polyhedron_texture = 'pigment {color Red} finish {Shiny}'
      glass_texture = 'pigment {color Clear}'//
     & ' finish {ambient 0.2 diffuse 0.15'//
     & ' specular 0.3 reflection 0.1 refraction 1 ior 1.05}'
      do i = 1, MAXTEXT
         povtext(i) = object_texture
         usepovtext(i) = .false.
      enddo
c
c.....Set default names for the graphical objects:
c
      obj_name = 'Pol1'
      mol_name = 'Mol1'
c
c.....Initialize additional elements:
c
      sky_type = 0
      floor_type = 0
      wall_type = 0
c
      end
