c
c-----------------------------------------------------------------------
c
      subroutine readpoints (datafile, uout)
c
c.....readpoints - read the polyhedron description as an POINTS file.
c
      include           'implicit.inc'
      include           'error.inc'
      include           'polyhedron.inc'
      include           'strtools.inc'
c
      character*(*)     datafile
      integer           uout
c
      integer           luo, j, ndim, leng, fopen
c
c.....Open the input file:
c
      if (fopen (luo, datafile, ioread) .eq. ioerror) then
         write (uout,*) 'readpoints: Data file is ',
     &               datafile(1:leng(datafile))
         call error ('readpoints', 'I/O error when opening points file',
     &               faterr)
         return
      endif
c
      read (luo,*) ndim
      read (luo,*) nvert
      do j = 1, nvert
         read (luo,*) xvert(j), yvert(j), zvert(j)
      enddo
      nvf = 0
      nface(0) = 0
      nface(1) = 0
c
      call fclose (luo)
c
      write (uout,100) datafile(1:leng(datafile)), nvert
 100  format (/
     & 1x, 'READPOINTS: Reading start points from a file'/
     & 1x, 'Data file name: ', a/
     & 1x, 'Points read in: ', i6)
c
      end
