c
c-----------------------------------------------------------------------
c
      subroutine setvariables (line, lp, uout)
c
c.....setvariables - run time change of some program variables.
c
      implicit none
      include           'consts.inc'
      include           'datatm.inc'
      include           'error.inc'
      include           'molge.inc'
      include           'polyhedron.inc'
      include           'pov.inc'
c
      character*(*)     line
      integer           lp, uout
c
      logical           ok, ok1, done
      character*(300)   word
      character*(2)     name
      integer           iii, lw, oldlp, atmZ, charge
      real*8            xxx(3), rrr
c
      integer           leng, zhlookup
      logical           setint, setdble, setlogical
      character*(300)   uppcase, getword
c
      character*(1)     BLANK
      parameter         (BLANK = ' ')
c
      word = getword (word, line, lp)
      word = uppcase (word)
      lw = leng(word)
c
c.......................................................................
      if (word(1:lw) .eq. 'CAMANGLE') then
c.......................................................................
c
         ok = setdble (xxx(1), line, lp)
         ok = ok .and. setdble (xxx(2), line, lp)
         ok = ok .and. setdble (xxx(3), line, lp)
         if (ok) then
            camangle(1) = xxx(1)
            camangle(2) = xxx(2)
            camangle(3) = xxx(3)
            write (uout,600) camangle(1), camangle(2), camangle(3)
         else
            write (uout,601) camangle(1), camangle(2), camangle(3)
         endif
c
c.......................................................................
      else if (word(1:lw) .eq. 'ZOOM') then
c.......................................................................
c
         ok = setdble (xxx(1), line, lp)
         if (ok) then
            zoom = xxx(1)
            write (uout,605) zoom
         else
            write (uout,606) zoom
         endif
c
c.......................................................................
      else if (word(1:lw) .eq. 'LIGHT') then
c.......................................................................
c
c........Check for a change in the default status:
c
         oldlp = lp
         word = getword (word, line, lp)
         word = uppcase (word)
         lw = leng (word)
         if (word(1:lw) .eq. 'DEFAULT') then
            def_light = .true.
            write (uout,700) 'Default lights? .true.'
         else if (word(1:lw) .eq. 'NODEFAULT') then
            def_light = .false.
            write (uout,700) 'Default lights? .false.'
         else
            lp = oldlp
         endif
c
c........Is a new light being added?
c
         ok = setint (iii, line, lp)
         if (ok) then
            if (iii.le.0 .or. iii.gt.MLIGHT) call error ('setvariables',
     &         'SET LIGHT error: wrong or too large number of light',
     &         faterr)
            ok = setdble (xxx(1), line, lp)
            ok = ok .and. setdble (xxx(2), line, lp)
            ok = ok .and. setdble (xxx(3), line, lp)
            if (ok) then
               if (iii .gt. n_light) n_light = iii
               use_light(iii)   = .true.
               r_light(iii)     = xxx(1)
               theta_light(iii) = xxx(2)
               phi_light(iii)   = xxx(3)
c
c..............look for the light color:
c
               do while (line(lp:lp) .eq. BLANK)
                  lp = lp + 1
               enddo
               lw = leng (line)
               if (lw .gt. lp) then
                  col_light(iii) = line(lp:lw)
               else
                  col_light(iii) = 'White'
               endif
               write (uout,701) iii, r_light(iii), theta_light(iii),
     &                          phi_light(iii),
     &                          col_light(iii)(1:leng(col_light(iii)))
            else
               call error ('setvariables', 'SET LIGHT error', faterr)
            endif
         endif
c
c.......................................................................
      else if (word(1:lw) .eq. 'AXES') then
c.......................................................................
c
         ok = setlogical (putaxes, line, lp)
         write (uout,610) putaxes
c
c.......................................................................
      else if (word(1:lw) .eq. 'EQUALSCALE') then
c.......................................................................
c
         word = getword (word, line, lp)
         word = uppcase (word)
         lw = leng (word)
         if (word(1:lw) .eq. 'ALL') then
            equalscale = scale_all
            write (uout,615) 'all'
         else if (word(1:lw) .eq. 'XY' .or. word(1:lw) .eq. 'YX') then
            equalscale = scale_xy
            write (uout,615) 'xy'
         else if (word(1:lw) .eq. 'XZ' .or. word(1:lw) .eq. 'ZX') then
            equalscale = scale_xz
            write (uout,615) 'xz'
         else if (word(1:lw) .eq. 'YZ' .or. word(1:lw) .eq. 'ZY') then
            equalscale = scale_yz
            write (uout,615) 'yz'
         else if (word(1:lw) .eq. 'NONE') then
            equalscale = scale_none
            write (uout,615) 'none'
         else if (word(1:lw) .eq. 'NOSCALE') then
            equalscale = scale_noscale
            write (uout,615) 'no scale'
         else
            write (uout,616)
         endif
c
c.......................................................................
      else if (word(1:lw) .eq. '3MIRRORS') then
c.......................................................................
c
         ok = setlogical (mirrors, line, lp)
         ok = ok .and. setdble (mirrx, line, lp)
         ok = ok .and. setdble (mirry, line, lp)
         ok = ok .and. setdble (mirrz, line, lp)
         write (uout,620) mirrors, mirrx, mirry, mirrz
c
c.......................................................................
      else if (word(1:lw) .eq. 'FULLPOV') then
c.......................................................................
c
         ok = setlogical (fullpov, line, lp)
         write (uout,625) fullpov
c
c.......................................................................
      else if (word(1:lw) .eq. 'DEF_TEXTURE') then
c.......................................................................
c
         lw = leng(line)
         if (lw .gt. lp) def_texture = line(lp:lw)
         write (uout,630) 'New default texture: '//
     &         def_texture(1:leng(def_texture))
c
c.......................................................................
      else if (word(1:lw) .eq. 'OBJECT_TEXTURE') then
c.......................................................................
c
         lw = leng(line)
         if (lw .gt. lp) object_texture = line(lp:lw)
         write (uout,630) 'New object texture: '//
     &         object_texture(1:leng(object_texture))
c
c.......................................................................
      else if (word(1:lw) .eq. 'STICK_TEXTURE') then
c.......................................................................
c
         lw = leng(line)
         if (lw .gt. lp) stick_texture = line(lp:lw)
         write (uout,630) 'New stick texture: '//
     &         stick_texture(1:leng(stick_texture))
c
c.......................................................................
      else if (word(1:lw) .eq. 'BALL_TEXTURE') then
c.......................................................................
c
         lw = leng(line)
         if (lw .gt. lp) ball_texture = line(lp:lw)
         write (uout,630) 'New ball texture: '//
     &         ball_texture(1:leng(ball_texture))
c
c.......................................................................
      else if (word(1:lw) .eq. 'POLYHEDRON_TEXTURE') then
c.......................................................................
c
         lw = leng(line)
         if (lw .gt. lp) polyhedron_texture = line(lp:lw)
         write (uout,630) 'New polyhedron texture: '//
     &         polyhedron_texture(1:leng(polyhedron_texture))
c
c.......................................................................
      else if (word(1:lw) .eq. 'GLASS_TEXTURE') then
c.......................................................................
c
         lw = leng(line)
         if (lw .gt. lp) glass_texture = line(lp:lw)
         write (uout,630) 'New glass texture: '//
     &         glass_texture(1:leng(glass_texture))
c
c.......................................................................
      else if (word(1:lw) .eq. 'POV_TEXTURE') then
c.......................................................................
c
         ok = setint (iii, line, lp)
         ok = ok .and. (iii.gt.0 .and. iii.le.MAXTEXT)
         if (ok) then
            lw = leng(line)
            if (lw .gt. lp) povtext(iii) = line(lp:lw)
            usepovtext(iii) = .true.
            write (uout,632) iii, povtext(iii)(1:lw-lp+1)
         endif
c
c.......................................................................
      else if (word(1:lw) .eq. 'BACKGROUND') then
c.......................................................................
c
         lw = leng(line)
         if (lw .gt. lp) def_background = line(lp:lw)
         write (uout,630) 'New default background: '//
     &         def_background(1:leng(def_background))
c
c.......................................................................
      else if (word(1:lw) .eq. 'OBJECT_NAME') then
c.......................................................................
c
         lw = leng(line)
         if (lw .gt. lp) obj_name = line(lp:lw)
         write (uout,645) obj_name(1:leng(obj_name))
c
c.......................................................................
      else if (word(1:lw) .eq. 'MOL_NAME') then
c.......................................................................
c
         lw = leng(line)
         if (lw .gt. lp) mol_name = line(lp:lw)
         write (uout,646) mol_name(1:leng(mol_name))
c
c.......................................................................
      else if (word(1:lw) .eq. 'BASINCLIP') then
c.......................................................................
c
         ok = setlogical (basinclip, line, lp)
         write (uout,650) basinclip
c
c.......................................................................
      else if (word(1:lw) .eq. 'LOGINTERPOL') then
c.......................................................................
c
         ok = setlogical (loginterpol, line, lp)
         write (uout,655) loginterpol
c
c.......................................................................
      else if (word(1:lw) .eq. 'USE_PLANES') then
c.......................................................................
c
         ok = setlogical (use_planes, line, lp)
         write (uout,660) use_planes
c
c.......................................................................
      else if (word(1:lw) .eq. 'SKY') then
c.......................................................................
c
         word = getword (word, line, lp)
         word = uppcase (word)
         lw = leng (word)
         if (word(1:lw) .eq. 'FILE') then
            word = getword (word, line, lp)
            lw = leng (word)
            if (lw .gt. 0) then
               sky_file = word(1:lw)
               sky_type = -1
               write (uout,700) 'New sky file: '//word(1:lw)
            else
               call error ('setvariables', 'Sky file error', faterr)
            endif
         else if (word(1:lw) .eq. 'TYPE') then
            ok = setint (iii, line, lp)
            if (ok) then
               sky_type = iii
               write (uout,705) 'New sky type: ', sky_type
            else
               call error ('setvariables', 'Sky type error', faterr)
            endif
         endif
c
c.......................................................................
      else if (word(1:lw) .eq. 'FLOOR') then
c.......................................................................
c
         word = getword (word, line, lp)
         word = uppcase (word)
         lw = leng (word)
         if (word(1:lw) .eq. 'FILE') then
            word = getword (word, line, lp)
            lw = leng (word)
            if (lw .gt. 0) then
               floor_file = word(1:lw)
               floor_type = -1
               write (uout,700) 'New floor file: '//word(1:lw)
            else
               call error ('setvariables', 'floor file error', faterr)
            endif
         else if (word(1:lw) .eq. 'TYPE') then
            ok = setint (iii, line, lp)
            if (ok) then
               floor_type = iii
               write (uout,705) 'New floor type: ', floor_type
            else
               call error ('setvariables', 'floor type error', faterr)
            endif
         endif
c
c.......................................................................
      else if (word(1:lw) .eq. 'WALL') then
c.......................................................................
c
         word = getword (word, line, lp)
         word = uppcase (word)
         lw = leng (word)
         if (word(1:lw) .eq. 'FILE') then
            word = getword (word, line, lp)
            lw = leng (word)
            if (lw .gt. 0) then
               wall_file = word(1:lw)
               wall_type = -1
               write (uout,700) 'New wall file: '//word(1:lw)
            else
               call error ('setvariables', 'wall file error', faterr)
            endif
         else if (word(1:lw) .eq. 'TYPE') then
            ok = setint (iii, line, lp)
            if (ok) then
               wall_type = iii
               write (uout,705) 'New wall type: ', wall_type
            else
               call error ('setvariables', 'wall type error', faterr)
            endif
         endif
c
c.......................................................................
      else if (word(1:lw) .eq. 'LENGTHUNIT') then
c.......................................................................
c
         word = getword (word, line, lp)
         word = uppcase (word)
         lw = leng (word)
         if (word(1:lw) .eq. 'ANGSTROM') then
            lengthtype = langstrom
            write (uout,700) 'Distances are entered in: Ansgtrom'
            rconversion = 1d0 / bohr2a
         else if (word(1:lw) .eq. 'BOHR') then
            lengthtype = lbohr
            write (uout,700) 'Distances are entered in: Bohr'
            rconversion = 1d0
         else if (word(1:lw) .eq. 'PM') then
            lengthtype = lpm
            write (uout,700) 'Distances are entered in: pm'
            rconversion = 1d0 / bohr2pm
         else
            write (uout,700)
     &            'Wrong length unit. Use: angstrom, bohr, pm'
         endif
c
c.......................................................................
      else if (word(1:lw) .eq. 'RADTYPE') then
c.......................................................................
c
         word = getword (word, line, lp)
         word = uppcase (word)
         lw = leng (word)
         if (word(1:lw) .eq. 'IONIC') then
            typrad = typION
            write (uout,700) 'Use IONIC radii as defaults'
         else if (word(1:lw) .eq. 'VDW') then
            typrad = typvdW
            write (uout,700) 'Use van der Waals radii as defaults'
         else if (word(1:lw) .eq. 'COV') then
            typrad = typCOV
            write (uout,700) 'Use COVALENT radii as defaults'
         else
            write (uout,700)
     &            'Wrong radius type given sin SET RADTYPE order'
         endif
         word = getword (word, line, lp)
         word = uppcase (word)
         lw = leng (word)
         done = lw .le. 0
         do while (.not. done)
            if (word(1:lw) .eq. 'GRFACTOR') then
               ok = setdble (xxx(1), line, lp)
               if (ok) then
                  write (uout,710) 'New graphical radii factor ', xxx(1)
                  grfactor = xxx(1)
               else
                  write (uout,700) 'Wrong graphical radius factor'
               endif
            else if (word(1:lw) .eq. 'FACTOR') then
               ok = setdble (xxx(1), line, lp)
               oldlp = lp
               ok1 = ok .and. setint (iii, line, lp)
               if (.not. ok1) lp = oldlp
               if (ok1) then
                  ionfactor(iii) = xxx(1)
                  write (uout,715) 'New bond radius factor for charge',
     &                             iii, ':', xxx(1)
               else if (ok) then
                  write (uout,710) 'New bond radius factor for all'//
     &                             ' charges: ', xxx(1)
                  do iii = -3, 7
                     ionfactor(iii) = xxx(1)
                  enddo
               else
                  write (uout,700) 'Wrong bond radius factor'
               endif
            endif
            if (ok) then
               word = getword (word, line, lp)
               word = uppcase (word)
               lw = leng (word)
               done = lw .le. 0
            else
               done = .true.
            endif
         enddo
c
c.......................................................................
      else if (word(1:lw) .eq. 'CAMERA') then
c.......................................................................
c
         write (uout,720) 'Explicitely setting new camera parameters'
         word = getword (word, line, lp)
         word = uppcase (word)
         lw = leng (word)
         done = lw .le. 0
         do while (.not. done)
            if (word(1:lw) .eq. 'COP') then
               ok = setdble (xxx(1), line, lp)
               ok = ok .and. setdble (xxx(2), line, lp)
               ok = ok .and. setdble (xxx(3), line, lp)
               if (ok) then
                  usecamangle = .false.
                  write (uout,725) 'New center of projection',
     &                             xxx(1), xxx(2), xxx(3)
                  COP(1) = xxx(1)
                  COP(2) = xxx(2)
                  COP(3) = xxx(3)
               else
                  write (uout,700) 'Wrong COP specification'
               endif
            else if (word(1:lw) .eq. 'SKY') then
               ok = setdble (xxx(1), line, lp)
               ok = ok .and. setdble (xxx(2), line, lp)
               ok = ok .and. setdble (xxx(3), line, lp)
               if (ok) then
                  write (uout,725) 'New sky direction',
     &                             xxx(1), xxx(2), xxx(3)
                  SKY(1) = xxx(1)
                  SKY(2) = xxx(2)
                  SKY(3) = xxx(3)
                  VUV(1) = xxx(1)
                  VUV(2) = xxx(2)
                  VUV(3) = xxx(3)
               else
                  write (uout,700) 'Wrong SKY specification'
               endif
            else if (word(1:lw) .eq. 'RHT') then
               ok = setdble (xxx(1), line, lp)
               ok = ok .and. setdble (xxx(2), line, lp)
               ok = ok .and. setdble (xxx(3), line, lp)
               if (ok) then
                  write (uout,725) 'New right direction',
     &                             xxx(1), xxx(2), xxx(3)
                  RHT(1) = xxx(1)
                  RHT(2) = xxx(2)
                  RHT(3) = xxx(3)
               else
                  write (uout,700) 'Wrong RHT specification'
               endif
            else if (word(1:lw) .eq. 'DRT') then
               ok = setdble (xxx(1), line, lp)
               ok = ok .and. setdble (xxx(2), line, lp)
               ok = ok .and. setdble (xxx(3), line, lp)
               if (ok) then
                  write (uout,725) 'New THIRD direction',
     &                             xxx(1), xxx(2), xxx(3)
                  DRT(1) = xxx(1)
                  DRT(2) = xxx(2)
                  DRT(3) = xxx(3)
               else
                  write (uout,700) 'Wrong DRT specification'
               endif
            else if (word(1:lw) .eq. 'VRP') then
               ok = setdble (xxx(1), line, lp)
               ok = ok .and. setdble (xxx(2), line, lp)
               ok = ok .and. setdble (xxx(3), line, lp)
               if (ok) then
                  usecamangle = .false.
                  write (uout,725) 'New look_at direction',
     &                             xxx(1), xxx(2), xxx(3)
                  VRP(1) = xxx(1)
                  VRP(2) = xxx(2)
                  VRP(3) = xxx(3)
               else
                  write (uout,700) 'Wrong VRP specification'
               endif
            endif
            if (ok) then
               word = getword (word, line, lp)
               word = uppcase (word)
               lw = leng (word)
               done = lw .le. 0
            else
               done = .true.
            endif
         enddo
c
c.......................................................................
      else if (word(1:lw) .eq. 'ATOMICDATA') then
c.......................................................................
c
         name = uppcase (getword (word, line, lp))
         atmZ = zhlookup (name)
         if (atmZ .le. 0) call error ('setvariables',
     &      'Atom name not recognized!', faterr)
         word = getword (word, line, lp)
         word = uppcase (word)
         lw = leng (word)
         done = lw .le. 0
         do while (.not. done)
            if (word(1:lw) .eq. 'IONIC') then
               ok = setint (charge, line, lp)
               ok = ok .and. setdble (rrr, line, lp)
               if (ok) then
                  write (uout,670) name, atmZ, charge, rrr
                  atmION(charge,atmZ) = int(rrr)
               endif
            else if (word(1:lw) .eq. 'COVALENT') then
               ok = setdble (rrr, line, lp)
               if (ok) then
                  write (uout,675) 'covalent', name, atmZ, rrr
                  atmcov(atmZ) = int(rrr)
               endif
            else if (word(1:lw) .eq. 'vdW') then
               ok = setdble (rrr, line, lp)
               if (ok) then
                  write (uout,675) 'van der Waals', name, atmZ, rrr
                  atmvdW(atmZ) = int(rrr)
               endif
            else
               ok = .false.
            endif
            if (ok) then
               word = getword (word, line, lp)
               word = uppcase (word)
               lw = leng (word)
               done = lw .le. 0
            else
               call error ('setvariables',
     &         'Error in ATOMICDATA input line', warning)
               done = .true.
            endif
         enddo
c
c.......................................................................
      else
c.......................................................................
c
         call error ('setvariables' , 'variable not recognized', faterr)
c
      endif
      return
c
c.....FORMATS:
c
 600  format (/
     & 1x, 'SET: New camera angles: ', 3f12.4)
 601  format (/
     & 1x, 'SET: Error providing new camera angles. Use: ', 3f12.4)
 605  format (/
     & 1x, 'SET: New zoom parameter: ', f12.4)
 606  format (/
     & 1x, 'SET: Error reading new zoom. Use: ', f12.4)
 610  format (/
     & 1x, 'SET: Include axes in POV output? ', l2)
 615  format (/
     & 1x, 'SET: Equal scale mode: ', a)
 616  format (/
     & 1x, 'SET: Unknown scale mode. Use: ALL | XY | XZ | YZ | NONE')
 620  format (/
     & 1x, 'SET: Include mirrors in POV output? ', l2/
     & 1x, '     Mirrors distances to the origin ', 1p, 3e12.4)
 625  format (/
     & 1x, 'SET: Output a complete POV scene? ', l2)
 630  format (/
     & 1x, 'SET: ', a)
 632  format (/
     & 1x, 'SET: New POV-Ray texture (#', i3, '): ', a)
 645  format (/
     & 1x, 'SET: New object name: ', a)
 646  format (/
     & 1x, 'SET: New molecular object name: ', a)
 650  format (/
     & 1x, 'SET: Clip density surface to the basin limits? ', l2)
 655  format (/
     & 1x, 'SET: Use log interpolation to get the isosurfaces? ', l2)
 660  format (/
     & 1x, 'SET: Use planes for polyhedra in POV? ', l2)
 670  format (/
     & 1x, 'SET: New ionic radius for atom ', a2, '(Z=', i3, ')',
     & 1x, 'charge=', i2, ' ---> ', f8.2)
 675  format (/
     & 1x, 'SET: New ', a, ' radius for atom ', a2, '(Z=', i3, ')',
     & 1x, ' ---> ', f8.2)
 700  format (/
     & 1x, 'SET: ', a)
 701  format (/
     & 1x, 'SET: Added new light #', i3, ' Position:', 3f12.6,
     & 1x, 'Color:', a)
 705  format (/
     & 1x, 'SET: ', a, i3)
 710  format (/
     & 1x, 'SET: ', a, 1p, e14.6)
 715  format (/
     & 1x, 'SET: ', a, i3, a, 1p, e14.6)
 720  format (/1x, 'SET: ', a)
 725  format (1x, '--- ', a, ' :', 3f12.6)
c
      end
